﻿using System;
using OrderManagement.DataMirroring.Models;
using Shared.Interfaces;

namespace OrderManagement.DataMirroring
{
  public class CustomerUpdatedEvent : IApplicationEvent
  {
    public CustomerUpdatedEvent(Customer customer, bool isNew) : this()
    {
      Customer = customer;
      IsNew = isNew;
    }

    private CustomerUpdatedEvent()
    {
      DateTimeEventOccurred = DateTime.Now;
    }

    public Customer Customer { get; private set; }
    public bool IsNew { get; private set; }
    public DateTime DateTimeEventOccurred { get; set; }

    public string EventType
    {
      get { return "CustomerUpdatedEvent"; }
    }
  }
}