﻿using OrderManagement.DataMirroring.DataPersistence;
using OrderManagement.DataMirroring.Models;
using Shared.Interfaces;

namespace OrderManagement.DataMirroring
{
  public class CustomerUpdatedHandler : IHandle<CustomerUpdatedEvent>
  {
    public void Handle(CustomerUpdatedEvent customerUpdatedEvent)
    {
      Customer customer = customerUpdatedEvent.Customer;
      using (var mgr = new SimpleRepo())
      {
        if (customerUpdatedEvent.IsNew)
        {
          mgr.InsertCustomer(customer);
        }
        else
        {
          mgr.UpdateCustomer(customer);
        }
      }
    }
  }
}