﻿using System.Data.Entity;
using OrderManagement.DataMirroring.Models;

namespace OrderManagement.DataMirroring.DataPersistence
{
  public class CustomersContext : DbContext
  {
    public DbSet<Customer> Customers { get; set; }
  }

  public class MyDbConfiguration : DbConfiguration
  {
    public MyDbConfiguration()
    {
      //With this set here, running the windows service (really a console app),
      //will cause Entity Framework to execute the migrations:
      //initial will create the database and its base schema
      //ModifyCustomerSchema will apply a small change to the db schema

      this.SetDatabaseInitializer(new MigrateDatabaseToLatestVersion<CustomersContext,
                                      OrderManagement.DataMirroring.Migrations.Configuration>());
    }
  }
}