﻿using System;
using OrderManagement.DataMirroring.Models;

namespace OrderManagement.DataMirroring.DataPersistence
{
  public class SimpleRepo : IDisposable
  {
    public void Dispose()
    {
    }

    public void InsertCustomer(Customer customer)
    {
      using (var context = new CustomersContext())
      {
        context.Customers.Add(customer);
        context.SaveChanges();
      }
    }

    public void UpdateCustomer(Customer customer)
    {
      using (var context = new CustomersContext())
      {
        context.Database.ExecuteSqlCommand(
          "exec ReplaceCustomer {0}, {1}",
          customer.CustomerId, customer.ClientName);
      }
    }
  }
}